import { HttpClient } from '@angular/common/http';
import 'rxjs';
export declare class HttpPresetService {
    private http;
    static me: HttpPresetService;
    static httpOptions: any;
    token: string;
    baseURL: string;
    constructor(http: HttpClient);
    /**
     * Perform http get resquest
     *
     * @param {string} url request url. example: http://www.mon-api.net/article ou http://www.mon-api.net/article/1 (dans le cas où l'on souhaite recuppérer un seule élement).
     */
    get(url: string): any;
    /**
     * Perform http post request
     *
     * @param {string} url  request url. example: http://www.mon-api.net/article
     * @param {any}    data json datas.
     */
    post(url: string, data: any): any;
    /**
     * Perform http put request
     *
     * @param {string} url  url request. example: http://www.mon-api.net/article/1
     * @param {any}    data json datas.
     */
    put(url: string, data: any): any;
    /**
     * Perform http delete request
     *
     * @param {string} url request url. example: http://www.mon-api.net/article/1
     */
    delete(url: string): any;
    /**
     * Define token
     *
     * @param {string} token [description]
     */
    setToken(token: string): void;
    /**
     * Define base url of api
     *
     * @param {string} url [description]
     */
    setBaseURL(url: string): void;
    /**
     * Define resource of route api
     * @param {string}            name     name of route
     * @param {string}            method   http method (GET, POST, PUT, DELETE)
     * @param {any = null}        data     json data formated
     * @param {string = null}     id       item id
     * @param {boolean = false}   token    tell if token must be used
     */
    resource(name: string, method: string, data?: any, id?: string, token?: boolean): any;
    /**
      * Convert json to x-www-url-encoded
      *
      * @param {any[]} jsonElt [description]
      */
    private jsonToUrlEncoded(jsonElt);
}
